  function [res,sol] = bicgstab (A,rhs,x0,m,tol) 
%%--------------------------------------------------
% function [res,sol] = bicgstab(A,rhs,x0, m, tol) 
% x0  = initial guess on entry -- 
% rhs = rhs, m = number of sttol --
% m   = max number of sttol 
% tol = tolerance
% res = residuals.. 
% sol = app sol on return 
%%--------------------------------------------------
 sol  = x0; 
 r    = rhs - A * sol; 
 r0   = r;
 p    = r ; 
 ro1  = r' * r; 
 res(1) = sqrt(ro1) ;
 tol1 = tol*res(1);
%
 for j=1:m 
     ro  = ro1; 
     Ap  = A * p; 
     alp = ro / (r0'*Ap) ;      %% !! check div by 0
     s   = r - alp * Ap ;
     As  = A*s;
     om  = (s'*As) / (As'*As);  %% !! check div by 0
     sol = sol + alp*p + om*s;
     r   = s - om * As; 
     rsn = norm(r);   res(j+1) = rsn;    
     if (rsn < tol1) 
        break
     end
     ro1 = r0'*r;
     bet = (ro1/ro)*(alp/om);   %% !! check div by 0
     p   = r + bet * (p-om*Ap); 
 end
 
         
