addpath ../sparse
A = fd3d(20, 20, 5, 0.1, -0.2, 0.1, 0.0);
n = size(A,1);
rhs = A*[1:n]';
x0 = randn(n,1);
tol = 1.e-10; m = 200;
[res1,sol] = gmres0(A,rhs,x0,30,tol,m) ;
[res2,sol] = BiCG (A, rhs, x0, m, tol) ;
[res3,sol] = cgs (A, rhs, x0, m, tol);
[res4,sol] = bcgstab(A, rhs, x0, m, tol) ;
semilogy(res1,'k');
hold 
semilogy(res2,'r-');
semilogy(res3,'b-');
semilogy(res4,'r--');
legend('gmres','bicg','cgs', 'bcgstab')
